// 2021 12 11

// использование
// upos.sh init
// upos.sh ping|closeday dir_out prefix
// upos.sh pay|cancel|preauth amount dir_out prefix
// upos.sh postauth amount dir_out prefix rnn

// коды выхода
// 0 - успех
// 1 - устройство не найдено / не отвечает / ошибка выполнение операции, нужно смотреть *e
// 2 - нет зарегистрированного OLE
// 3 - недостаточно аргументов
// 4 - неизвестное действие
// 5 - отсутствует директория для сохранения результата

var WshShell = WScript.CreateObject("WScript.Shell");
var fso = WScript.CreateObject("Scripting.FileSystemObject");
var installDir = fso.GetParentFolderName(WScript.ScriptFullName);
var scriptArgs = WScript.Arguments;
var path = WScript.FullName.toLowerCase();
var scripthost = fso.GetFileName(path);
var script = WScript.ScriptFullName;
var arch = WshShell.ExpandEnvironmentStrings("%PROCESSOR_ARCHITECTURE%").toLowerCase();
var sysdir = WshShell.ExpandEnvironmentStrings("%WINDIR%");
var statusFile = "";
var resultFile = "";
var errorFile = "";
var list = "";
var resultext = "";
var rrn = "";
var SBRFSRV;
var res,pinres,amount = 0;

function createOLE(){
	try {
		SBRFSRV = WScript.CreateObject("SBRFSRV.Server");
	}
	catch (e) {
		if((typeof SBRFSRV != "object") || (SBRFSRV == null)) {
			exitstatus(2);
		}
	}
}
// Запрос готовности пинпада
function devcheck(SBRFSRV){
	pinres = SBRFSRV.NFun(13);
	return pinres;
}
// Запись результата в файл (переменные) (p)
function writeresult(resultext,action) {
	var result = fso.OpenTextFile(filepath+"\\"+action+"_"+fileprefix+"_p", 8, true);
	result.WriteLine(resultext);
	result.Close();
}
// Запись чека в файл (c)
function writecheck(resultext,action) {
	var result = fso.OpenTextFile(filepath+"\\"+action+"_"+fileprefix+"_c", 8, true);
	result.WriteLine(resultext);
	result.Close();
}
// Запись статуса (e)
function writestatus(res,action) {
	var status = fso.OpenTextFile(filepath+"\\"+action+"_"+fileprefix+"_e", 8, true);
	status.WriteLine(res);
	status.Close();
	exitstatus(res)
}
// код выхода в консоли
function exitstatus(res) {
	if (res > 10) {
		var exitcode=1;
	} else {
		var exitcode=res;
	}

	if (scripthost.indexOf('cscript') >= 0) {
		WScript.Echo("sbercode: "+res);
		WScript.Echo("exitcode: "+exitcode);
	}
	WScript.Quit(exitcode);
}
// выполнение произвольной функции
function nfun (func,SBRFSRV) {
	res = SBRFSRV.NFun(func);
	return res;
}
// Запрос статуса операции
function getparams (SBRFSRV) {
	var TermNum = SBRFSRV.GParamString("TermNum");
	var ClientCard = SBRFSRV.GParamString("ClientCard");
	var ClientExpiryDate = SBRFSRV.GParamString("ClientExpiryDate");
	var AuthCode = SBRFSRV.GParamString("AuthCode");
	var CardName = SBRFSRV.GParamString("CardName");
	var CardType = SBRFSRV.GParamString("CardType");
	var CardData = SBRFSRV.GParamString("CardData");
	var Cheque = SBRFSRV.GParamString("Cheque");
	var TrxDate = SBRFSRV.GParamString("TrxDate");
	var TrxTime = SBRFSRV.GParamString("TrxTime");
	var MerchNum = SBRFSRV.GParamString("MerchNum");
	var RRN = SBRFSRV.GParamString("RRN");
	var MerchantTSN = SBRFSRV.GParamString("MerchantTSN");
	var MerchantBatchNum = SBRFSRV.GParamString("MerchantBatchNum");
	var Hash = SBRFSRV.GParamString("Hash");
	writeresult("TermNum="+TermNum,action);
	writeresult("ClientCard="+ClientCard,action);
	writeresult("ClientExpiryDate="+ClientExpiryDate,action);
	writeresult("AuthCode="+AuthCode,action);
	writeresult("CardName="+CardName,action);
	writeresult("CardType="+CardType,action);
	writeresult("MerchNum="+MerchNum,action);
	writeresult("RRN="+RRN,action);
	writeresult("MerchantTSN="+MerchantTSN,action);
	writeresult("MerchantBatchNum="+MerchantBatchNum,action);
	writeresult("TrxDate="+TrxDate+TrxTime,action);
	writeresult("Hash="+Hash,action);
	writecheck(Cheque,action);
}

// Оплата покупки
function pay(amount,SBRFSRV) {
	SBRFSRV.Clear();
	SBRFSRV.SParam("Amount", amount);
	res = SBRFSRV.NFun(4000);
	return res;
}

// Оплата покупки биометрией
function paybio(amount,face,SBRFSRV) {
	SBRFSRV.Clear();
	SBRFSRV.SParam("Amount", amount);
	SBRFSRV.SParam("InText", face);
	res = SBRFSRV.NFun(4032);
	return res;
}

// предавторизация
function preauth(amount,SBRFSRV) {
	SBRFSRV.Clear();
	SBRFSRV.SParam("Amount", amount);
	res = SBRFSRV.NFun(4009);
	return res;
}
// завершение расчета
function postauth(amount,rrn,SBRFSRV) {
	SBRFSRV.Clear();
	SBRFSRV.SParam("Amount", amount);
	SBRFSRV.SParam("RRN", rrn);
	res = SBRFSRV.NFun(4010);
	return res;
}
// Отмена покупки
function cancel(amount,SBRFSRV) {
	SBRFSRV.Clear();
	SBRFSRV.SParam("Amount", amount);
	res = SBRFSRV.NFun(4002);
	return res;
}
// Закрытие дня
function closeday(SBRFSRV) {
	SBRFSRV.Clear();
	res = SBRFSRV.NFun(6000);
	return res;
}
// Запрос информации по карте
function getcardinfo(SBRFSRV) {
	SBRFSRV.Clear();
	res = SBRFSRV.NFun(5002);
	return res;
}

if (scriptArgs.Count()>0) {
	if (path.indexOf('system32') >= 0 && arch=="amd64") {
		for (var i=0; i<=scriptArgs.Count()-1; i++) {
			list += WScript.Arguments(i)+" ";
		}
		res = WshShell.Run(sysdir+"\\SysWOW64\\"+scripthost+" \""+script+"\" "+list,1,true);
		exitstatus(res)
	} else {
		var action = WScript.Arguments(0);
		// init
		if (action=="init") {
			exitstatus(0);
		}

		createOLE();
		if (scriptArgs.Count()<3) {
			exitstatus(3);
		}
		if (scriptArgs.Count()>4) {
			var filepath = WScript.Arguments(3);
			var fileprefix = WScript.Arguments(4);
		} else if (scriptArgs.Count()>3) {
			var filepath = WScript.Arguments(2);
			var fileprefix = WScript.Arguments(3);
		} else {
			var filepath = WScript.Arguments(1);
			var fileprefix = WScript.Arguments(2);
		}
		if (!fso.FolderExists(filepath)) {
			exitstatus(5);
		}
		if (fso.FileExists(filepath+"\\"+action+"_"+fileprefix+"_p")) {
		 fso.DeleteFile(filepath+"\\"+action+"_"+fileprefix+"_p", true);
		}
		if (fso.FileExists(filepath+"\\"+action+"_"+fileprefix+"_c")) {
		 fso.DeleteFile(filepath+"\\"+action+"_"+fileprefix+"_c", true);
		}
		if (fso.FileExists(filepath+"\\"+action+"_"+fileprefix+"_e")) {
		 fso.DeleteFile(filepath+"\\"+action+"_"+fileprefix+"_e", true);
		}

		if (devcheck(SBRFSRV) == 0) {
			if (action=="pay") {
				if (scriptArgs.Count()>3) {
					amount = WScript.Arguments(1);
					if (pay(amount,SBRFSRV) == 0) {
						getparams(SBRFSRV);
					}
					writestatus(res,action);
				} else {
					// недостаточно аргументов
					exitstatus(3);
				}
			} else if (action=="bio") {
				if (scriptArgs.Count()>3) {
					amount = WScript.Arguments(1);
					face = WScript.Arguments(2);
					if (paybio(amount, face, SBRFSRV) == 0) {
						getparams(SBRFSRV);
					}
					writestatus(res,action);
				} else {
					// недостаточно аргументов
					exitstatus(3);
				}
			} else if (action=="paycancel") {
				if (scriptArgs.Count()>3) {
					amount = WScript.Arguments(1);
					if (pay(amount,SBRFSRV) == 0) {
						nfun (6003,SBRFSRV);
						getparams(SBRFSRV);
					}
					writestatus(res,action);
				} else {
					// недостаточно аргументов
					exitstatus(3);
				}
			} else if (action=="cancel") {
				if (scriptArgs.Count()>3) {
					amount = WScript.Arguments(1);
					if (cancel(amount,SBRFSRV) == 0) {
						getparams(SBRFSRV);
					}
					writestatus(res,action);
				} else {
					// недостаточно аргументов
					exitstatus(3);
				}
			} else if (action=="preauth") {
				if (scriptArgs.Count()>3) {
					amount = WScript.Arguments(1);
					if (preauth(amount,SBRFSRV) == 0) {
						getparams(SBRFSRV);
					}
					writestatus(res,action);
				} else {
					// недостаточно аргументов
					exitstatus(3);
				}
			} else if (action=="postauth") {
				if (scriptArgs.Count()>4) {
					amount = WScript.Arguments(1);
					rrn = WScript.Arguments(4);
					if (postauth(amount,rrn,SBRFSRV) == 0) {
						getparams(SBRFSRV);
					}
					writestatus(res,action);
				} else {
					// недостаточно аргументов
					exitstatus(3);
				}
                        } else if (action=="confirmation") {
				nfun (6001,SBRFSRV);
				writestatus(res,action);
			} else if (action=="cancellation") {
				nfun (6004,SBRFSRV);
				writestatus(res,action);
			} else if (action=="closeday") {
				closeday(SBRFSRV);
				getparams(SBRFSRV);
				writestatus(res,action);
			} else if (action=="ping") {
				writestatus(pinres,action);
			} else if (action=="cardinfo") {
				getcardinfo(SBRFSRV);
				getparams(SBRFSRV);
				writestatus(res,action);
			} else {
				// неизвестное действие
				exitstatus(4);
			}
		} else {
			writestatus(pinres,action);
		}
	}
} else {
	// аргументы действий не переданы
	exitstatus(3);
}
